
import java.io.*;
import java.util.Iterator;

/**
 This class will read text files.

 @author  SJSU Students
 @version 1.01 10/24/2012
 */
class TextFileReader implements Iterable<String>
{
   /**
    This class will read the files.

    @param fileName the name of the file that is going to be read.
    @throws IOException
    */
   public TextFileReader(String fileName) throws IOException
   {
      reader = new BufferedReader(new FileReader(fileName));
   }

   /**
    Closes the reader after it's used.
    @throws Throwable
    */
   @Override
   public void finalize() throws Throwable
   {
      reader.close();
   }

   /**
    The iterator interface that is used to read through the files.
    */
   @Override
   public Iterator<String> iterator()
   {
      return new Iterator<String>()
      {
         private String line = null;

         /**
          If the file has a next line
          @return true if it has a next line, false otherwise.
          */
         @Override
         public boolean hasNext()
         {
            try
            {
               line = reader.readLine();
               if (line != null)
               {
                  return true;
               }
               else
               {
                  reader.close();
                  return false;
               }
            }
            catch (IOException e)
            {
               throw new RuntimeException(e);
            }
         }

         /**
          Find the next line in the file.
          @return the next line
          */
         @Override
         public String next()
         {
            return line;
         }

         @Override
         public void remove()
         {
            throw new UnsupportedOperationException();
         }
      };
   }
   //The reader variable to read the text files.
   private BufferedReader reader;
}
